> For the complete documentation index, see [llms.txt](https://docs.hemi.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hemi.xyz/building-bitcoin-apps/hemi-virtual-machine-hvm/deploy-on-hvm.md).

# Deploy on hVM

{% hint style="warning" %}
This documentation page is outdated and may not reflect current information.
{% endhint %}

{% hint style="info" %}

## 📜 **TL;DR:**

* To use hVM directly, you will have to call the appropriate precompile address with the appropriate serialized bytes to pass parameters to the function.&#x20;
* Most dApp developers will use the Hemi Bitcoin Kit (hBK) **rather** than hVM directly.&#x20;
  {% endhint %}

***

## 🌐 Overview

* To use hVM directly, you will have to call the appropriate precompile address with the appropriate serialized bytes to pass parameters to the function.&#x20;
* Each successful precompile call will return serialized bytes according to the precompile’s return data specification.

***

## 🟨 Developer Tip

> **Most dApp developers will use the Hemi Bitcoin Kit (hBK) rather than hVM directly.**&#x20;

* If you’re looking for an easy way to get started developing Bitcoin-aware dApps on Hemi, check out the “Hemi Bitcoin Kit (hBK)” section. Understanding how Bitcoin Kit uses hVM under-the-hood may be helpful, and dApp developers looking to maximize gas efficiency may benefit from using hVM directly to avoid paying overhead for unmarshalling data they don’t need for a specific use case.

###


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hemi.xyz/building-bitcoin-apps/hemi-virtual-machine-hvm/deploy-on-hvm.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
